package com.devdaily.xylocator;

import com.apple.eawt.ApplicationAdapter;
import com.apple.eawt.ApplicationEvent;

/**
 * XYLocator - A simple application to determine the X/Y coordinates of the cursor.
 * Also gets the RGB color at that point.
 * 
 * Copyright 2010, Alvin J. Alexander, devdaily.com.
 * 
 * This file is part of the devdaily.com XYLocator application.
 * 
 * XYLocator is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * XYLocator is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XYLocator. If not, see <http://www.gnu.org/licenses/>.
 *
 */
public class MyApplicationAdapter extends ApplicationAdapter
{
  private XYLocator handler;
  
  public MyApplicationAdapter(XYLocator handler)
  {
    this.handler = handler;
  }

  public void handleQuit(ApplicationEvent e)
  {
    handler.doQuitAction();
  }

  public void handlePreferences(ApplicationEvent e)
  {
    handler.doPreferencesAction();
  }

//  public void handleAbout(ApplicationEvent e)
//  {
//    // tell the system we're handling this, so it won't display
//    // the default system "about" dialog after ours is shown.
//    e.setHandled(true);
//    handler.handleAboutAction();
//  }
}












