package com.devdaily.xylocator;

import java.awt.event.*;
import javax.swing.*;
import com.jgoodies.forms.builder.DefaultFormBuilder;
import com.jgoodies.forms.factories.ButtonBarFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * Copyright 2010, Alvin J. Alexander, devdaily.com.
 * 
 * This file is part of the devdaily.com XYLocator application.
 * 
 * XYLocator is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * XYLocator is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XYLocator. If not, see <http://www.gnu.org/licenses/>.
 *
 */
public class XYMainFrame extends JFrame
{
  private JButton goButton = new JButton("Get X/Y");
  private JButton quitButton = new JButton("Quit");
  private JTextArea textArea = new JTextArea(5,30);
  private JScrollPane scrollPane = new JScrollPane(textArea);
  private JLabel statusLabel = new JLabel(" ");
  XYLocator controller;

  public XYMainFrame(XYLocator controller)
  {
    this.controller = controller;
    setTitle("devdaily.com :: get x/y & color");
    goButton.addActionListener(new XYMainFrame_goButton_actionAdapter(this));
    quitButton.addActionListener(new XYMainFrame_quitButton_actionAdapter(this));
    getContentPane().add(buildPanel(), java.awt.BorderLayout.CENTER);
    pack();
  }

  private JComponent buildPanel() 
  {
    JLabel header = new JLabel("Get X/Y Coordinates and Color");

    //@todo Fix this layout
    FormLayout layout = new FormLayout("pref:grow",
                                       "pref, 6dlu,pref,3dlu,pref:grow,3dlu,pref");
    DefaultFormBuilder builder = new DefaultFormBuilder(layout);
    builder.setDefaultDialogBorder();
    CellConstraints cc = new CellConstraints();
    builder.add(header, cc.xy(1, 1));
    builder.add(ButtonBarFactory.buildOKCancelBar(goButton, quitButton), cc.xy(1, 3));
    builder.add(scrollPane, cc.xy(1, 5));
    builder.add(statusLabel, cc.xy(1, 7));
    return builder.getPanel();
  }

  public void goButton_actionPerformed(ActionEvent e)
  {
    controller.doGetXYAndColorAction();
  }

  public void quitButton_actionPerformed(ActionEvent e)
  {
    controller.doExitAction();
  }

  public void setCoordinateInformation(String s)
  {
    textArea.setText(s);
  }
  public void setStatus(String s)
  {
    statusLabel.setText(s);
  }
}

class XYMainFrame_quitButton_actionAdapter implements ActionListener
{
  private XYMainFrame adaptee;
  XYMainFrame_quitButton_actionAdapter(XYMainFrame adaptee)
  {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e)
  {
    adaptee.quitButton_actionPerformed(e);
  }
}

class XYMainFrame_goButton_actionAdapter implements ActionListener
{
  private XYMainFrame adaptee;
  XYMainFrame_goButton_actionAdapter(XYMainFrame adaptee)
  {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e)
  {
    adaptee.goButton_actionPerformed(e);
  }
}

